using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace WildTrain
{
    class Cowboy
    {

        private enum States
        {
            Running,
            Blocking,
            Damaging,
            Rolling,
            Fleing,
            
        }

        //private bool friendly;
        private bool alive;
        private Texture2D texture;
        private Texture2D puff;
        private States State;
        private States Action;
        private float speed = 2;
        private float position = 0;
        private int target_position;
        private int shoot_delay = 1000;
        private int last_shot;
        private int puff_ttl = 200;
        //private int puff_created;
        private bool has_puff = false;
        private int damage;

        //private int height;
        

        public Cowboy(bool damaging, int temp_damage, bool temp_friendly)
        {

            //Chance to change friendlyship
            Random random = new Random();
            if (random.Next(1, 5) == 1)
                temp_friendly = !temp_friendly;


            if (damaging)
            {
                Action = States.Damaging;
                target_position = 200;
            }
            else
            {
                Action = States.Blocking;
                target_position = 530;
            }

            //If friendly, target out of screen
            if (temp_friendly)
                target_position = 900;

            position = 0;
            State = States.Running;
            texture = LoadHelper.Textures[TextureEnum.cowboy];
            puff = LoadHelper.Textures[TextureEnum.puff];
            last_shot = -1;
            alive = true;
            position = -texture.Width - 10;
            damage = temp_damage;
        }
        public void Kill()
        {
            State = States.Rolling;

        }

        public bool Alive()
        {
            return alive;
        }

        public void Update(GameTime gameTime, Train _train)
        {
            if (position < -texture.Width-100 || position > 900)
                alive = false;
            switch (State)
            {
                case States.Running:
                    if (position < target_position)
                        position = position + speed;
                    else State = Action;


                    break;
                case States.Blocking:
                    break;
                case States.Damaging:
                    if (last_shot == -1)
                    {
                        last_shot = (int)gameTime.TotalGameTime.TotalMilliseconds;
                    }
                    if ((int)gameTime.TotalGameTime.TotalMilliseconds - last_shot > shoot_delay)
                    {
                        last_shot = (int)gameTime.TotalGameTime.TotalMilliseconds;

                        _train.Hit(damage);
                        has_puff = true;
                    }

                    if (has_puff && ((int)gameTime.TotalGameTime.TotalMilliseconds - last_shot > puff_ttl))
                        has_puff = false;

                    break;
                case States.Fleing:
                    break;
                case States.Rolling:
                    position = position - speed*2f;

                    break;




            }

            

        }


        public void Draw(SpriteBatch spritebatch)
        {
            
            if (has_puff == true)
                spritebatch.Draw(puff, new Rectangle(90, (int)position + 50, puff.Width, puff.Height), Color.White);

            spritebatch.Draw(texture, new Rectangle(0, (int)position, texture.Width, texture.Height), Color.White);
            spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial22], position.ToString(), new Vector2(30, 210), Color.White);


        }
    }
}
