using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace WildTrain
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        public enum GameState
        {
            Start,
            Intro,
            Menu,
            Game,
			Exit
        }

        private Intro _Intro;
        private Menu _Menu;
        private static Level _Level;


        public static GameState State = GameState.Menu;

        public Game1()
        {

            graphics = new GraphicsDeviceManager(this);
            graphics.PreferredBackBufferWidth = 480;
            graphics.PreferredBackBufferHeight = 800;
            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here


            //_Intro = new Intro();
			TouchPanel.EnabledGestures = GestureType.Tap;

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
		///

        public static void StartLevel(int index)
        {
            switch (index)
            {
                case 1:
                    _Level = new Level(LoadHelper.Textures[TextureEnum.background],
                                            LoadHelper.Textures[TextureEnum.foreground],
                                            LoadHelper.Textures[TextureEnum.tracks],
                                            LoadHelper.Textures[TextureEnum.mine],
                                            400,
                                            LoadHelper.Textures[TextureEnum.town],
                                            3300,
                                            LoadHelper.Textures[TextureEnum.goal1],
                                            19400,
                                            147,
                                            1000,
                                            true,
                                            true,
                                            false,
                                            3000.0f,
                                            9999.9f,
                                            true,
                                            1);

                    break;
                case 2:
                    _Level = new Level(LoadHelper.Textures[TextureEnum.background],
                                            LoadHelper.Textures[TextureEnum.foreground],
                                            LoadHelper.Textures[TextureEnum.tracks],
                                            LoadHelper.Textures[TextureEnum.town],
                                            400,
                                            LoadHelper.Textures[TextureEnum.town],
                                            3300,
                                            LoadHelper.Textures[TextureEnum.goal2],
                                            19400,
                                            12,
                                            1000,
                                            true,
                                            true,
                                            false,
                                            3000.0f,
                                            9999.9f,
                                            true,
                                            1);
                    break;
                case 3:
                    break;





            }

        }

        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            LoadHelper.Load(Content);
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {

			if (State == GameState.Exit) this.Exit();

            graphics.GraphicsDevice.Clear(Color.Black);
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            switch (State)
            {
                

                case GameState.Intro:
                    if (_Intro == null)
                        _Intro = new Intro();
                    _Intro.Update(gameTime);
                    if ((float)gameTime.TotalGameTime.Seconds > 3) State = GameState.Menu;

                    //_Intro.Update(gameTime);

                    break;
                case GameState.Menu:
                    if (_Menu == null)
                        _Menu = new Menu();
                    _Menu.Update(gameTime);
                    break;
                case GameState.Game:
                    if (_Level == null)
                        StartLevel(1); 
                        
                     _Level.Update(gameTime);
                    break;
            }
            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {

            GraphicsDevice device = graphics.GraphicsDevice;

            graphics.GraphicsDevice.Clear(Color.Black);

            spriteBatch.Begin();


            switch (State)
            {
                case GameState.Intro:
                    if (_Intro == null)
                        _Intro = new Intro();                
                    _Intro.Draw(spriteBatch);

                    break;
                case GameState.Menu:
                    if (_Menu == null)
                        _Menu = new Menu();
                    _Menu.Draw(spriteBatch);
                    break;
                case GameState.Game:
                    _Level.Draw(spriteBatch);
                    break;
            }


            spriteBatch.End();
            // TODO: Add your drawing code here

            base.Draw(gameTime);
        }
    }
}
