using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;



namespace WildTrain
{
    class Level
    {

        private int level_index;
        
        private string time;
		
        private float distance;
        private float target_distance;
        private float score;
		private int price_water = 150;
		private int price_coal = 100;
		private int price_bomb = 200;
		private int price_tool = 300;
        private float track2_position = LoadHelper.Textures[TextureEnum.tracks].Height;
        private int train_height = 90;
        //Random random = new Random();
        private Train _train;
        private bool enemies_cowboy;
        private bool enemies_cowboy_friendly;
        private bool enemies_train;
        private Scrollground _background;
        private Scrollground _foreground;
        private Scrollground _tracks;
        private Scrollground _foreground_item1;
        private Scrollground _foreground_item2;
        private Scrollground _foreground_item3;
        private HighScore _highscore;
        private Cowboy _cowboy;
        private ParticleSystem _smoke;
        
        private bool victory = false;

        private float enemy_cowboy_delay;
        private float enemy_train_delay;
        private int last_cowboy_created; 
        private Texture2D count_texture;
        private bool count_go = false;

        private int seconds;
        private bool help;
        private int count_seconds;
        private int level_time;
        private Color smokeColor;

        private enum States
        {
            Beggining,
            Counting,
            Running,
            Finnished
        }
        private States State = States.Running;

        public Level(Texture2D temp_texture_background,
                    Texture2D temp_texture_foreground,
                    Texture2D temp_texture_tracks,
                    Texture2D temp_start_item,
                    int temp_start_position,
                    Texture2D temp_finnish_item,
                    int temp_finnish_position,
                    Texture2D temp_goal,
                    int temp_goal_position,
                    int temp_length,
                    int temp_score,
                    bool temp_enemies_cowboys,
                    bool temp_enemies_cowboy_friendly,
                    bool temp_enemies_trains,
                    float temp_enemy_cowboy_delay,
                    float temp_enemy_train_delay,
                    bool temp_help,
                    int temp_index)
        {

            _train = new Train();
            _foreground_item1 = new Scrollground(temp_start_item,
                                                        false,
                                                        0.2f,
                                                        train_height,
                                                        temp_start_position);

            _foreground_item2 = new Scrollground(temp_finnish_item,
                                                    false,
                                                    0.2f,
                                                    train_height,
                                                    temp_finnish_position);

            _foreground_item3 = new Scrollground(temp_goal,
                                                    false,
                                                    1.3f,
                                                    0,
                                                    temp_goal_position);

            _background = new Scrollground(temp_texture_background,
                                            true,
                                            0.1f,
                                            0,
                                            0);

            _foreground = new Scrollground(temp_texture_foreground,
                                            true,
                                            1.3f,
                                            0,
                                            0);

            _tracks = new Scrollground(temp_texture_tracks,
                                               true,
                                               1.0f,
                                               train_height - temp_texture_tracks.Width,
                                               0);
			if (_smoke == null)
				_smoke = new ParticleSystem(LoadHelper.Textures[TextureEnum.smoke],
											new Vector2(480, 330),
											3000f, // Energy in milliseconds
											100f); // Frequency in milliseconds



            score = temp_score;     
            target_distance = temp_length;
            seconds = -1;
            level_index = temp_index;
            help = temp_help;
            count_seconds = -1;
            State = States.Counting;
            count_texture = LoadHelper.Textures[TextureEnum.count_3];
            enemy_cowboy_delay = temp_enemy_cowboy_delay;
            enemy_train_delay = temp_enemy_train_delay;
            enemies_cowboy = temp_enemies_cowboys;
            enemies_train = temp_enemies_trains;
            enemies_cowboy_friendly = temp_enemies_cowboy_friendly;
            last_cowboy_created = -1;
            _highscore = new HighScore();
        }

        public void Update(GameTime gameTime)
        {
            if (seconds == -1)
                seconds = (int)gameTime.TotalGameTime.TotalSeconds;

            switch (State)
            {
                case States.Counting:
                    if (count_seconds == -1)
                    {
                        count_seconds = (int)gameTime.TotalGameTime.TotalSeconds;
                        count_texture = LoadHelper.Textures[TextureEnum.count_3];
                    }
                    
                    if ((int)gameTime.TotalGameTime.TotalSeconds - seconds > 1)
                    {
                        count_texture = LoadHelper.Textures[TextureEnum.count_2];
                    }
                    if ((int)gameTime.TotalGameTime.TotalSeconds - seconds > 2)
                    {
                        count_texture = LoadHelper.Textures[TextureEnum.count_1];
                    }
                    if ((int)gameTime.TotalGameTime.TotalSeconds - seconds > 3)
                    {
                        count_texture = LoadHelper.Textures[TextureEnum.count_go];
                        State = States.Running;
                        count_go = true;
                    }


                    break;
                case States.Running:               
                    _train.Update(gameTime);
                    _foreground_item1.Update(gameTime, _train.GetSpeed());
                    _foreground_item2.Update(gameTime, _train.GetSpeed());
                    _foreground_item3.Update(gameTime, _train.GetSpeed());
                    _background.Update(gameTime, _train.GetSpeed());
                    _foreground.Update(gameTime, _train.GetSpeed());
                    _tracks.Update(gameTime, _train.GetSpeed());
                    score = score + _train.GetSpeed() * 0.1f;
                    distance = distance + _train.GetSpeed() * 0.01f;
					
						
					_smoke.Update(gameTime, new Vector2(-5, 10 / (_train.GetSpeed()+0.1f)), smokeColor);

                    if (count_go == true)
                    {
                        if ((int)gameTime.TotalGameTime.TotalSeconds - seconds > 4)
                        {
                            count_go = false;
                        }

                    }


                    if (enemies_cowboy)
                    {
                        if (_cowboy == null && ((int)gameTime.TotalGameTime.TotalMilliseconds - (enemy_cowboy_delay) > last_cowboy_created - _train.GetSpeed() * 70))
                        {
                            _cowboy = new Cowboy(true, 30, enemies_cowboy_friendly);
                            last_cowboy_created = (int)gameTime.TotalGameTime.TotalMilliseconds;
                        }
                            
                        _cowboy.Update(gameTime, _train);
                        if (!_cowboy.Alive())
                            _cowboy = null;

                    }

					if(TouchPanel.IsGestureAvailable) {

						var gesture = TouchPanel.ReadGesture();
						if (gesture.GestureType == GestureType.Tap && gesture.Position.Y > 690)
						{

							if (gesture.Position.X > 10 && gesture.Position.X < 110)
							{
								score = score - price_tool;
                                _train.Repair((float)gameTime.TotalGameTime.TotalMilliseconds);
								//Icon 4 pressed
								
							}
							if (gesture.Position.X > 120 && gesture.Position.X < 220)
							{

								score = score - price_bomb;
                                if (_cowboy != null)
                                    _cowboy.Kill();
								//Icon 3 pressed
							}
							if (gesture.Position.X > 240 && gesture.Position.X < 340)
							{
								score = score - price_coal;
                                _train.AddCoal((float)gameTime.TotalGameTime.TotalMilliseconds);
								//Icon 2 pressed
							}
							if (gesture.Position.X > 360 && gesture.Position.X < 460)
							{
								score = score - price_water;
                                _train.AddWater((float)gameTime.TotalGameTime.TotalMilliseconds);
								//Icon 1 pressed
							}
						}
                    }
                    if (_train.GetSpeed() == 0 || _train.GetHP() < 5)
                    {
                        victory = false;
                        State = States.Finnished;
                        level_time = (int)gameTime.TotalGameTime.TotalSeconds - seconds;
                    }
                    if (distance > target_distance)
                    {
                        victory = true;
                        State = States.Finnished;
                        level_time = (int)gameTime.TotalGameTime.TotalSeconds - seconds;
                    }

                    break;
                case States.Finnished:
                    
                    

                    switch (victory)
                    {
                        case true:

                            if (_highscore.GetScore(level_index) < (int)score)
                                _highscore.SaveScore(level_index, (int)score);
                            if (_highscore.GetTime(level_index) < level_time)
                                _highscore.SaveTime(level_index, level_time);

                            if (TouchPanel.IsGestureAvailable)
                            {

                                var gesture = TouchPanel.ReadGesture();
                                if (gesture.GestureType == GestureType.Tap && gesture.Position.X > 110 && gesture.Position.X < 205)
                                {

                                    if (gesture.Position.Y > 127 && gesture.Position.Y < 304)
                                    {
                                        //reload
                                        Game1.StartLevel(level_index);
                                    }
                                    if (gesture.Position.Y > 315 && gesture.Position.Y < 489)
                                    {
                                        //reload                                        
                                        Game1.StartLevel(level_index+1);
                                    }
                                    if (gesture.Position.Y > 498 && gesture.Position.Y < 612)
                                    {
                                        //exit to menu
                                        Game1.State = Game1.GameState.Menu;
                                    }

                                }
                            }
                            break;
                        case false:
                            if (TouchPanel.IsGestureAvailable)
                            {

                                var gesture = TouchPanel.ReadGesture();
                                if (gesture.GestureType == GestureType.Tap && gesture.Position.X > 110 && gesture.Position.X < 205)
                                {

                                    if (gesture.Position.Y > 186 && gesture.Position.Y < 360)
                                    {
                                        //reload
                                        Game1.StartLevel(level_index);
                                    }
                                    if (gesture.Position.Y > 440 && gesture.Position.Y < 620)
                                    {
                                        //exit to menu
                                        Game1.State = Game1.GameState.Menu;
                                    }
                                    
                                }
                            }
                            break;
                    }
                    break;
                case States.Beggining:
                    break;
                


            }


        }

        public void Draw(SpriteBatch spritebatch)
        {
            
            _background.Draw(spritebatch);
            _tracks.Draw(spritebatch);
            _foreground.Draw(spritebatch);
            _foreground_item1.Draw(spritebatch);
            _foreground_item2.Draw(spritebatch);

            

            //Train
            spritebatch.Draw(LoadHelper.Textures[TextureEnum.train], new Rectangle(train_height, 20, 244, 577), Color.White);
			_smoke.Draw(spritebatch);

            if (help)
            {
                if (_train.GetTemperature() > 200)
                    spritebatch.Draw(LoadHelper.Textures[TextureEnum.more_water], new Rectangle(190, 130, LoadHelper.Textures[TextureEnum.more_coal].Width, LoadHelper.Textures[TextureEnum.more_coal].Height), Color.White);
                

                if (_train.GetTemperature() < 60)
                    spritebatch.Draw(LoadHelper.Textures[TextureEnum.more_coal], new Rectangle(190, 130, LoadHelper.Textures[TextureEnum.more_coal].Width, LoadHelper.Textures[TextureEnum.more_coal].Height), Color.White);
            }

            if (_cowboy != null)
                _cowboy.Draw(spritebatch);

            _foreground_item3.Draw(spritebatch);
            //Items

            spritebatch.Draw(LoadHelper.Textures[TextureEnum.tool], new Rectangle(16, 690, 100, 100), Color.White);
            spritebatch.Draw(LoadHelper.Textures[TextureEnum.bomb], new Rectangle(100 + 16 * 2, 690, 100, 100), Color.White);
            spritebatch.Draw(LoadHelper.Textures[TextureEnum.coal], new Rectangle(200 + 16 * 3, 690, 100, 100), Color.White);
            spritebatch.Draw(LoadHelper.Textures[TextureEnum.water], new Rectangle(300 + 16 * 4, 690, 100, 100), Color.White);

            //Speed Bar


            switch (_train.Engine_State())
            {
                case 0:
					smokeColor = Color.White;
                    spritebatch.Draw(LoadHelper.Textures[TextureEnum.temp_bar], new Rectangle(200, 0, (int)(_train.GetTemperature() / 2), 25), Color.Red);
                    break;
                case 1:
					smokeColor = Color.Gray;
                    spritebatch.Draw(LoadHelper.Textures[TextureEnum.temp_bar], new Rectangle(200, 0, (int)(_train.GetTemperature() / 2), 25), Color.Yellow);
                    break;
                case 2:
					smokeColor = Color.Black;
                    spritebatch.Draw(LoadHelper.Textures[TextureEnum.temp_bar], new Rectangle(200, 0, (int)(_train.GetTemperature() / 2), 25), Color.Green);
                    break;
            }
            if (_train.GetHP() > 250*0.66f)
                spritebatch.Draw(LoadHelper.Textures[TextureEnum.temp_bar], new Rectangle(200, 30, (int)(_train.GetHP() / 2), 25), Color.Green);
            else if (_train.GetHP() > 250 * 0.33f)
                spritebatch.Draw(LoadHelper.Textures[TextureEnum.temp_bar], new Rectangle(200, 30, (int)(_train.GetHP() / 2), 25), Color.Yellow);
            else spritebatch.Draw(LoadHelper.Textures[TextureEnum.temp_bar], new Rectangle(200, 30, (int)(_train.GetHP() / 2), 25), Color.Red);
            spritebatch.Draw(LoadHelper.Textures[TextureEnum.bar], new Rectangle(200, 0, (int)(LoadHelper.Textures[TextureEnum.bar].Width / 2), (int)(LoadHelper.Textures[TextureEnum.bar].Height / 2)), Color.White);


            //Score
            spritebatch.Draw(LoadHelper.Textures[TextureEnum.icon_score], new Rectangle(480 - LoadHelper.Textures[TextureEnum.icon_score].Width, 0, LoadHelper.Textures[TextureEnum.icon_score].Width, LoadHelper.Textures[TextureEnum.icon_score].Height), Color.White);
            spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial22], ((int)(score)).ToString(), new Vector2(400, 15), Color.Yellow);

            spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial22], _train.GetTemperature().ToString(), new Vector2(30, 30), Color.Yellow);
            spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial22], _train.GetSpeed().ToString(), new Vector2(30, 60), Color.White);
            spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial22], _train.GetState(), new Vector2(30, 90), Color.White);
            spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial22], _train.Delay(), new Vector2(30, 120), Color.White);
            spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial22], _train.Time(), new Vector2(30, 150), Color.White);
            spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial22], ((int)distance).ToString(), new Vector2(30, 180), Color.White);


            if (State == States.Counting || count_go)
            {
                spritebatch.Draw(count_texture, new Rectangle(480/2 - (int)(count_texture.Width / 2), 800/2 - (int)(count_texture.Height / 2), count_texture.Width, count_texture.Height), Color.White);
            }



            if (State == States.Finnished)
            {

                switch (victory)
                {
                    case true:
                        if (level_time < 60)
                            time = "0:" + level_time.ToString();
                        else time = ((level_time - level_time % 60) / 60).ToString() + ":" + (level_time % 60).ToString();
                        spritebatch.Draw(LoadHelper.Textures[TextureEnum.victory], new Rectangle(0, 0, 480, 800), Color.White);
                        spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], ((int)(score)).ToString(), new Vector2(222, 222), Color.Yellow);
                        spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], time, new Vector2(222, 481), Color.Yellow);
                        spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], time, new Vector2(222, 481), Color.Yellow);
                        break;



                    case false:
                        spritebatch.Draw(LoadHelper.Textures[TextureEnum.game_over], new Rectangle(0, 0, 480, 800), Color.White);
                        break;
                }



            }

        }
    }
}