using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace WildTrain
{
    class Menu
    {
        private enum Views
        {
            Main,
            Level,
            Highscore,
			None
        };
       
        private Views View = Views.Main;
        private Views tmpView = Views.None;
        private int waitCount;

        private bool effect = false;
		private float activeButtonOffset;

        private float movement = 0;
        private string movementStr;
        private bool movementBool = false;
        private HighScore _highscore;


        public Menu()
        {
            _highscore = new HighScore();

        }

        public void Update(GameTime gameTime)
        {
            //TouchLocation touch = new TouchLocation();


            //Check Touch- position

				if (TouchPanel.IsGestureAvailable)
				{

					var gesture = TouchPanel.ReadGesture();

                    if (gesture.GestureType == GestureType.Tap)
                    {
                        switch (View)
                        {
                            case Views.Highscore:
                                if (gesture.Position.X < 115 & gesture.Position.Y < 115)
                                    View = Views.Main;
                                break;
                            case Views.Level:
                                if (gesture.Position.X < 115 & gesture.Position.Y < 115)
                                    View = Views.Main;
								if (gesture.Position.X > 205 && gesture.Position.X < 317
									&& gesture.Position.Y > 105 && gesture.Position.Y < 242)
								{
									Game1.StartLevel(1);
									Game1.State = Game1.GameState.Game;
								}
								if (gesture.Position.X > 205 && gesture.Position.X < 317
									&& gesture.Position.Y > 332 && gesture.Position.Y < 469)
								{
									Game1.StartLevel(2);
									Game1.State = Game1.GameState.Game;
								}
								if (gesture.Position.X > 205 && gesture.Position.X < 317
								&& gesture.Position.Y > 580 && gesture.Position.Y < 718)
								{
									Game1.StartLevel(3);
									Game1.State = Game1.GameState.Game;
								}
								if (gesture.Position.X > 52 && gesture.Position.X < 169
									&& gesture.Position.Y > 220 && gesture.Position.Y < 358)
								{
									Game1.StartLevel(4);
									Game1.State = Game1.GameState.Game;
								}
								if (gesture.Position.X > 52 && gesture.Position.X < 169
									&& gesture.Position.Y > 457 && gesture.Position.Y < 597)
								{
									Game1.StartLevel(5);
									Game1.State = Game1.GameState.Game;
								}
                                break;
                            case Views.Main:
                                if (gesture.Position.X > 130 & gesture.Position.X < 200)
                                {
                                    tmpView = Views.Highscore;
                                    this.movementStr = "High Score";
									this.activeButtonOffset = 200;
                                    waitCount = gameTime.TotalGameTime.Seconds;
                                }
                                if (gesture.Position.X > 245 & gesture.Position.X < 310)
                                {
                                    tmpView = Views.Level;
                                    this.movementStr = "New Game";
									this.activeButtonOffset = 300;
                                    waitCount = gameTime.TotalGameTime.Seconds;
                                }

                                if (gesture.Position.X < 115 & gesture.Position.Y < 115)
                                    WildTrain.Game1.State = Game1.GameState.Exit;

                                break;
                        }

                        // If button pressed, show effect.
                        this.effect = true;
                    }

				}
                // Delay the menu change (as seconds)
				// TODO: Need better timecount which is always same.
                if (gameTime.TotalGameTime.Seconds - waitCount >= 1 && tmpView!= Views.None && waitCount > 0)
                {
                    View = tmpView;

					this.tmpView = Views.None;
                    this.waitCount = -1;
                    this.effect = false;
                    this.movement = 0;
                    this.movementStr = "";
                    this.movementBool = false;
                }
            

        }

        public void Draw(SpriteBatch spritebatch)
        {

            switch (View)
            {
                case Views.Main:
                    spritebatch.Draw(LoadHelper.Textures[TextureEnum.mainmenu], new Rectangle(0, 0, 480, 800), Color.White);

                    if (!this.effect)
                    {
                        DrawText(LoadHelper.Fonts[FontEnum.Arial42], "New Game", 300f, spritebatch, 0f);
                        DrawText(LoadHelper.Fonts[FontEnum.Arial42], "High Scores", 200f, spritebatch, 0f);
                    }
                    else
                    {
                        if (!this.movementBool)
                        {
                            this.movement -= 3;
                            if (this.movement < -25)
                                this.movementBool = true;
                        }
                        else
                            this.movement += 6;

                        DrawText(LoadHelper.Fonts[FontEnum.Arial42], this.movementStr, this.activeButtonOffset, spritebatch, this.movement);


                        if (movement >= 100f)
                        {
                            this.effect = false;
                            this.movement = 0;
                            this.movementStr = "";
                            this.movementBool = false;
                        }
                    }
                    break;
                case Views.Level:
                    spritebatch.Draw(LoadHelper.Textures[TextureEnum.selectlevel], new Rectangle(0, 0, 480, 800), Color.White);
                    break;

                case Views.Highscore:

                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], _highscore.GetScore(5).ToString(), new Vector2(267, 60), Color.White);
                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], _highscore.GetScore(4).ToString(), new Vector2(267, 120), Color.White);
                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], _highscore.GetScore(3).ToString(), new Vector2(267, 164), Color.White);
                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], _highscore.GetScore(2).ToString(), new Vector2(267, 218), Color.White);
                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], _highscore.GetScore(1).ToString(), new Vector2(267, 269), Color.White);


                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], ((_highscore.GetTime(5) - _highscore.GetTime(5) % 60) / 60).ToString() + ":" + (_highscore.GetTime(5) % 60).ToString(), new Vector2(540, 60), Color.White);
                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], ((_highscore.GetTime(4) - _highscore.GetTime(4) % 60) / 60).ToString() + ":" + (_highscore.GetTime(4) % 60).ToString(), new Vector2(540, 120), Color.White);
                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], ((_highscore.GetTime(3) - _highscore.GetTime(3) % 60) / 60).ToString() + ":" + (_highscore.GetTime(3) % 60).ToString(), new Vector2(540, 164), Color.White);
                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], ((_highscore.GetTime(2) - _highscore.GetTime(2) % 60) / 60).ToString() + ":" + (_highscore.GetTime(2) % 60).ToString(), new Vector2(540, 218), Color.White);
                    spritebatch.DrawString(LoadHelper.Fonts[FontEnum.Arial42], ((_highscore.GetTime(1) - _highscore.GetTime(1) % 60) / 60).ToString() + ":" + (_highscore.GetTime(1) % 60).ToString(), new Vector2(540, 269), Color.White);



                    spritebatch.Draw(LoadHelper.Textures[TextureEnum.highscore], new Rectangle(0, 0, 480, 800), Color.White);
                    break;
            }
        }
        private void DrawText(SpriteFont font, string text, float offset, SpriteBatch spritebatch, float movement)
        {
            Vector2 myTextSize = font.MeasureString(text);

            spritebatch.DrawString(font, text, new Vector2(0, movement), Color.Black,
                (float)Math.PI / 2.0f,
                //new Vector2(-200, offset), 
                new Vector2(-800 / 2.0f + myTextSize.X / 2.0f, offset),
                1.0f, SpriteEffects.None, 0f);
        }
    }
}
