using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace WildTrain
{
    class ParticleSystem
    {

        private Texture2D texture;
        private Vector2 position;
        private Vector2 direction;
        private int amount = 0;
        private float energy;
        private List<Particle> Particles;
        private float frequency;



        private double last_particle_created;

        private struct item
        {
            private float time;
            private Vector2 position;
        }

        public ParticleSystem(Texture2D temp_texture, Vector2 temp_position, float temp_energy, float temp_frequency)
        {
            Particles = new List<Particle>();
            texture = temp_texture;
            position = temp_position;
            frequency = temp_frequency;
            //Random possible
            energy = temp_energy;



        }

        private void CreateParticle(GameTime gameTime, Vector2 temp_direction, Color color)
        {
            last_particle_created = gameTime.TotalGameTime.TotalMilliseconds;
            Particles.Add(new Particle(texture, position, temp_direction, energy, last_particle_created, color));

            amount++;

        }

        public void Update(GameTime gameTime, Vector2 temp_direction, Color color)
        {
            if (amount == 0) CreateParticle(gameTime, temp_direction, color);
            if (frequency < gameTime.TotalGameTime.TotalMilliseconds - last_particle_created)
                CreateParticle(gameTime, temp_direction, color);

            Particles.ForEach(delegate(Particle part)
            {
                if (energy < gameTime.TotalGameTime.TotalMilliseconds - part.created)
                    Particles.RemoveAt(Particles.IndexOf(part));
            });

            Particles.ForEach(delegate(Particle part)
            {
                part.Update(gameTime);
            });
        }

        public void Draw(SpriteBatch spritebatch)
        {
            foreach (Particle tmpParticle in Particles)
            {
                tmpParticle.Draw(spritebatch);

            }



        }


    }
}
