using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace WildTrain
{
    class Scrollground
    {

        private Texture2D Texture;
        private float scroll_rate;
        private float position1 = 0.0f;
        private float position2 = 0.0f;
        private int height = 0;
        private bool loop = false;

        public Scrollground(Texture2D temp_texture, bool temp_loop, float temp_scroll_rate, int temp_height, int temp_position)
        {
            Texture = temp_texture;
            loop = temp_loop;
            scroll_rate = temp_scroll_rate;
            height = temp_height;
            position1 = temp_position;
            if (loop) position2 = Texture.Height;


        }

        private void SetHeight(int temp)
        {
            height = temp;
        }
        private void SetLoop(bool temp)
        {
            loop = temp;
            if (loop) position2 = Texture.Height;
        }
        public void SetTexture(Texture2D temp)
        {
            Texture = temp;
        }
        public void SetScrollSpeed(float temp)
        {
            scroll_rate = temp;

        }
        public void SetPosition(float temp)
        {
            position1 = temp;
        }

        public void Update(GameTime gameTime, float train_speed)
        {
            position1 = position1 - train_speed * scroll_rate;
            if (loop)
            {
                position2 = position2 - train_speed * scroll_rate;
                if (position1 < -Texture.Height)
                    position1 = Texture.Height;
                if (position2 < -Texture.Height)
                    position2 = Texture.Height;

            }
        }


        public void Draw(SpriteBatch spritebatch)
        {
            spritebatch.Draw(Texture,
                             new Rectangle(height,
                                           (int)position1,
                                           Texture.Width,
                                           Texture.Height),
                             Color.White);
            if (loop) spritebatch.Draw(Texture,
                                        new Rectangle(height,
                                                    (int)position2,
                                                    Texture.Width,
                                                    Texture.Height),
                                        Color.White);
        }
    }
}
