using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace WildTrain
{
    class Train
    {

        private int hit_points = 250;
        private int max_hit_points = 250;
        private int engine_state = 0;
        //private float ticks;
        private float delay;
        private float Speed = 5;
        private float Temperature = 145.0f;
        private float acceleration_rate = 0.05f;
        private float air_drag = 0.05f;
		private float max_speed = 27;

        private bool adding_water;
        private bool adding_coal;
        private bool repairing;
        private float water_ttl = 500.0f;
        private float coal_ttl = 1800.0f;
        private float repair_ttl = 3000.0f;
        private float started_adding;
        private float water_effect = -0.7f;
        private float coal_effect = 0.5f;
        private float repair_effect = 1f;
        private float time_cooling_effect = 0.1f;
        private float max_heat = 250.0f;
        private float min_heat = 0.0f;

		//private float min_temp = 130.0f;
		//private float max_temp = 160.0f;
       

        //private float difference = 40.0f;

        public void AddWater(float time)
        {
            if (!adding_coal && !repairing)
            {
                started_adding = time;
                adding_water = true;
            }

        }

        public void AddCoal(float time)
        {
            if (!adding_water && !repairing)
            {
                started_adding = time;
                adding_coal = true;
            }
        }

        public int GetHP()
        {
            return hit_points;
        }

        public void Hit(int damage)
        {
            hit_points = hit_points - damage;
        }

        public void Repair(float time)
        {
            if (!adding_water && !adding_coal)
            {
                started_adding = time;
                repairing = true;
            }


        }
        

        public void Update(GameTime gameTime)
        {

            
			if (Temperature > 0)	Temperature = Temperature - time_cooling_effect;

            delay = (float)gameTime.TotalGameTime.TotalMilliseconds - started_adding;

            if (adding_coal)
            {
                if (Temperature < max_heat)
                    Temperature = Temperature + coal_effect;
                if (delay > coal_ttl)
                    adding_coal = false;



            }
            if (adding_water)
            {
                if (Temperature > min_heat)
                    Temperature = Temperature + water_effect;
                if (delay > water_ttl)
                    adding_water = false;
            }
            if (repairing)
            {
                if (hit_points < max_hit_points)
                    hit_points = (int)(hit_points + repair_effect);
                else
                    repairing = false;
                if (delay > repair_ttl)
                    repairing = false;
            }


            if (Temperature > 60 & Temperature < 200)
            {
                if (Temperature > 100 & Temperature < 160)
                {
                    engine_state = 2;
                    if (Speed < max_speed)
                        Speed = Speed + acceleration_rate;
                }
                else
                {
                    Speed = Speed - air_drag;
                    engine_state = 1;
                }
            }
            else
            {
                Speed = Speed - acceleration_rate;
                engine_state = 0;
            }

            Speed = Speed - ((max_hit_points - hit_points) / max_hit_points) * air_drag * 5;

            if (Speed < 0)
                Speed = 0;



        }

        public int Engine_State()
        {
            return engine_state;
        }
        public void Stop()
        {
            Speed = 0;
        }
        public string Time()
        {
            return started_adding.ToString();
        }
        public string Delay()
        {
            return (delay).ToString();
        }
        
        public int GetSpeed()
        {
            return (int)Speed;
        }
        public int GetTemperature()
        {
            return (int)Temperature;
        }
        public int GetMaxTemperature()
        {
            return (int)max_heat;
        }
        public string GetState()
        {
            if (adding_water) return "Adding water";
            if (adding_coal) return "adding_coal";
            else return "ok";
        }
    }
}
